/*
 * This file is part of the libopencm3 project.
 *
 * Copyright (C) 2013 Toshiaki Yoshida <yoshida@mpc.net>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

/*
 * HID Usage Tables
 *
 * 10/28/2004
 * Version 1.12
 */

/* Usage Pages */
#define USB_HID_UNDEFINED_PAGE			0x00
#define USB_HID_GENERIC_DESKTOP			0x01
#define USB_HID_SIMULATION			0x02
#define USB_HID_VR				0x03
#define USB_HID_SPORT				0x04
#define USB_HID_GAME				0x05
#define USB_HID_GENERIC_DEVICE			0x06
#define USB_HID_KEYBOARD_PAGE			0x07
#define USB_HID_LED				0x08
#define USB_HID_BUTTON_PAGE			0x09
#define USB_HID_ORDINAL				0x0a
#define USB_HID_TELEPHONY			0x0b
#define USB_HID_CONSUMER			0x0c
#define USB_HID_DIGITIZER_PAGE			0x0d
#define USB_HID_PID				0x0f
#define USB_HID_UNICODE				0x10
#define USB_HID_ALPHANUMERIC_DISPLAY_PAGE	0x14
#define USB_HID_MEDICAL_INSTRUMENTS		0x40
#define USB_HID_MONITOR				0x80
#define USB_HID_POWER_PAGE			0x84
#define USB_HID_BAR_CODE_SCANNER_PAGE		0x8c
#define USB_HID_SCALE				0x8d
#define USB_HID_MSR				0x8e
#define USB_HID_CAMERA				0x90
#define USB_HID_ARCADE				0x91
#define USB_HID_VENDOR_PAGE			0xff00

/* Generic Desktop Page */
#define USB_HID_USAGE_ID_UNDEFINED		0x00
#define USB_HID_POINTER				0x01
#define USB_HID_MOUSE				0x02
#define USB_HID_JOYSTICK			0x04
#define USB_HID_GAME_PAD			0x05
#define USB_HID_KEYBOARD			0x06
#define USB_HID_KEYPAD				0x07
#define USB_HID_MULTI_AXIS_CONTROLLER		0x08
#define USB_HID_TABLET_PC_SYSTEM_CONTROLS	0x09
#define USB_HID_X				0x30
#define USB_HID_Y				0x31
#define USB_HID_Z				0x32
#define USB_HID_RX				0x33
#define USB_HID_RY				0x34
#define USB_HID_RZ				0x35
#define USB_HID_SLIDER				0x36
#define USB_HID_DIAL				0x37
#define USB_HID_WHEEL				0x38
#define USB_HID_HAT_SWITCH			0x39
#define USB_HID_COUNTED_BUFFER			0x3a
#define USB_HID_BYTE_COUNT			0x3b
#define USB_HID_MOTION_WAKEUP			0x3c
#define USB_HID_START				0x3d
#define USB_HID_SELECT				0x3e
#define USB_HID_VX				0x40
#define USB_HID_VY				0x41
#define USB_HID_VZ				0x42
#define USB_HID_VBRX				0x43
#define USB_HID_VBRY				0x44
#define USB_HID_VBRZ				0x45
#define USB_HID_VNO				0x46
#define USB_HID_FEATURE_NOTIFICATION		0x47
#define USB_HID_RESOLUTION_MULTIPLIER		0x48
#define USB_HID_SYSTEM_CONTROL			0x80
#define USB_HID_SYSTEM_POWER_DOWN		0x81
#define USB_HID_SYSTEM_SLEEP			0x82
#define USB_HID_SYSTEM_WAKE_UP			0x83
#define USB_HID_SYSTEM_CONTEXT_MENU		0x84
#define USB_HID_SYSTEM_MAIN_MENU		0x85
#define USB_HID_SYSTEM_APP_MENU			0x86
#define USB_HID_SYSTEM_MENU_HELP		0x87
#define USB_HID_SYSTEM_MENU_EXIT		0x88
#define USB_HID_SYSTEM_MENU_SELECT		0x89
#define USB_HID_SYSTEM_MENU_RIGHT		0x8a
#define USB_HID_SYSTEM_MENU_LEFT		0x8b
#define USB_HID_SYSTEM_MENU_UP			0x8c
#define USB_HID_SYSTEM_MENU_DOWN		0x8d
#define USB_HID_SYSTEM_COLD_RESTART		0x8e
#define USB_HID_SYSTEM_WARM_RESTART		0x8f
#define USB_HID_D_PAD_UP			0x90
#define USB_HID_D_PAD_DOWN			0x91
#define USB_HID_D_PAD_RIGHT			0x92
#define USB_HID_D_PAD_LEFT			0x93
#define USB_HID_SYSTEM_DOCK			0xa0
#define USB_HID_SYSTEM_UNDOCK			0xa1
#define USB_HID_SYSTEM_SETUP			0xa2
#define USB_HID_SYSTEM_BREAK			0xa3
#define USB_HID_SYSTEM_DEBUGGER_BREAK		0xa4
#define USB_HID_APPLICATION_BREAK		0xa5
#define USB_HID_APPLICATION_DEBUGGER_BREAK	0xa6
#define USB_HID_SYSTEM_SPEAKER_MUTE		0xa7
#define USB_HID_SYSTEM_HIBERNATE		0xa8
#define USB_HID_SYSTEM_DISPLAY_INVERT		0xb0
#define USB_HID_SYSTEM_DISPLAY_INTERNAL		0xb1
#define USB_HID_SYSTEM_DISPLAY_EXTERNAL		0xb2
#define USB_HID_SYSTEM_DISPLAY_BOTH		0xb3
#define USB_HID_SYSTEM_DISPLAY_DUAL		0xb4
#define USB_HID_SYSTEM_DISPLAY_TOGGLE		0xb5
#define USB_HID_SYSTEM_DISPLAY_SWAP		0xb6
#define USB_HID_SYSTEM_DISPLAY_LCD_AUTOSCALE	0xb7

/* Simulation Controls Page */
#define USB_HID_FLIGHT_SIMULATION		0x01
#define USB_HID_AUTOMOBILE_SIMULATION		0x02
#define USB_HID_TANK_SIMULATION			0x03
#define USB_HID_SPACESHIP_SIMULATION		0x04
#define USB_HID_SUBMARINE_SIMULATION		0x05
#define USB_HID_SAILING_SIMULATION		0x06
#define USB_HID_MOTORCYCLE_SIMULATION		0x07
#define USB_HID_SPORTS_SIMULATION		0x08
#define USB_HID_AIRPLANE_SIMULATION		0x09
#define USB_HID_HELICOPTER_SIMULATION		0x0a
#define USB_HID_MAGIC_CARPET_SIMULATION		0x0b
#define USB_HID_BICYCLE_SIMULATION		0x0c
#define USB_HID_FLIGHT_CONTROL_STICK		0x20
#define USB_HID_FLIGHT_STICK			0x21
#define USB_HID_CYCLIC_CONTROL			0x22
#define USB_HID_CYCLIC_TRIM			0x23
#define USB_HID_FLIGHT_YOKE			0x24
#define USB_HID_TRACK_CONTROL			0x25
#define USB_HID_AILERON				0xb0
#define USB_HID_AILERON_TRIM			0xb1
#define USB_HID_ANTI_TORQUE_CONTROL		0xb2
#define USB_HID_AUTOPILOT_ENABLE		0xb3
#define USB_HID_CHAFF_RELEASE			0xb4
#define USB_HID_COLLECTIVE_CONTROL		0xb5
#define USB_HID_DIVE_BRAKE			0xb6
#define USB_HID_ELECTRONIC_COUNTEMEASURES	0xb7
#define USB_HID_ELEVATOR			0xb8
#define USB_HID_ELEVATOR_TRIM			0xb9
#define USB_HID_RUDDER				0xba
#define USB_HID_THROTTLE			0xbb
#define USB_HID_FLIGHT_COMMUNICATIONS		0xbc
#define USB_HID_FLARE_RELEASE			0xbd
#define USB_HID_LANDING_GEAR			0xbe
#define USB_HID_TOE_BRAKE			0xbf
#define USB_HID_TRIGGER				0xc0
#define USB_HID_WEAPONS_ARM			0xc1
#define USB_HID_WEAPONS_SELECT			0xc2
#define USB_HID_WING_FLAPS			0xc3
#define USB_HID_ACCELERATOR			0xc4
#define USB_HID_BRAKE				0xc5
#define USB_HID_CLUTCH				0xc6
#define USB_HID_SHIFTER				0xc7
#define USB_HID_STEERING			0xc8
#define USB_HID_TURRET_DIRECTION		0xc9
#define USB_HID_BARREL_ELEVATION		0xca
#define USB_HID_DIVE_PLANE			0xcb
#define USB_HID_BALLAST				0xcc
#define USB_HID_BICYCLE_CRANK			0xcd
#define USB_HID_HANDLE_BARS			0xce
#define USB_HID_FRONT_BRAKE			0xcf
#define USB_HID_REAR_BRAKE			0xd0

/* VR Controls Page */
#define USB_HID_BELT				0x01
#define USB_HID_BODY_SUIT			0x02
#define USB_HID_FLEXOR				0x03
#define USB_HID_GLOVE				0x04
#define USB_HID_HEAD_TRACKER			0x05
#define USB_HID_HEAD_MOUNTED_DISPLAY		0x06
#define USB_HID_HAND_TRACKER			0x07
#define USB_HID_OCULOMETER			0x08
#define USB_HID_VEST				0x09
#define USB_HID_ANIMATRONIC_DEVICE		0x0a
#define USB_HID_STEREO_ENABLE			0x20
#define USB_HID_VR_DISPLAY_ENABLE		0x21

/* Sport Controls Page */
#define USB_HID_BASEBALL_BAT			0x01
#define USB_HID_GOLF_CLUB			0x02
#define USB_HID_ROWING_MACHINE			0x03
#define USB_HID_TREADMILL			0x04
#define USB_HID_OAR				0x30
#define USB_HID_SLOPE				0x31
#define USB_HID_RATE				0x32
#define USB_HID_STICK_SPEED			0x33
#define USB_HID_STICK_FACE_ANGLE		0x34
#define USB_HID_STICK_HEEL_TOE			0x35
#define USB_HID_STICK_FOLLOW_THROUGH		0x36
#define USB_HID_STICK_TEMPO			0x37
#define USB_HID_STICK_TYPE			0x38
#define USB_HID_STICK_HEIGHT			0x39
#define USB_HID_PUTTER				0x50
#define USB_HID_1_IRON				0x51
#define USB_HID_2_IRON				0x52
#define USB_HID_3_IRON				0x53
#define USB_HID_4_IRON				0x54
#define USB_HID_5_IRON				0x55
#define USB_HID_6_IRON				0x56
#define USB_HID_7_IRON				0x57
#define USB_HID_8_IRON				0x58
#define USB_HID_9_IRON				0x59
#define USB_HID_10_IRON				0x5a
#define USB_HID_11_IRON				0x5b
#define USB_HID_SAND_WEDGE			0x5c
#define USB_HID_LOFT_WEDGE			0x5d
#define USB_HID_POWER_WEDGE			0x5e
#define USB_HID_1_WOOD				0x5f
#define USB_HID_3_WOOD				0x60
#define USB_HID_5_WOOD				0x61
#define USB_HID_7_WOOD				0x62
#define USB_HID_9_WOOD				0x63

/* Game Controls Page */
#define USB_HID_3D_GAME_CONTROLLER		0x01
#define USB_HID_PINBALL_DEVICE			0x02
#define USB_HID_GUN_DEVICE			0x03
#define USB_HID_POINT_OF_VIEW			0x20
#define USB_HID_TURN_RIGHT_LEFT			0x21
#define USB_HID_PITCH_FORWARD_BACKWARD		0x22
#define USB_HID_ROLL_RIGHT_LEFT			0x23
#define USB_HID_MOVE_RIGHT_LEFT			0x24
#define USB_HID_MOVE_FORWARD_BACKWARD		0x25
#define USB_HID_MOVE_UP_DOWN			0x26
#define USB_HID_LEAN_RIGHT_LEFT			0x27
#define USB_HID_LEAN_FORWARD_BACKWARD		0x28
#define USB_HID_HEIGHT_OF_POV			0x29
#define USB_HID_FLIPPER				0x2a
#define USB_HID_SECONDARY_FLIPPER		0x2b
#define USB_HID_BUMP				0x2c
#define USB_HID_NEW_GAME			0x2d
#define USB_HID_SHOOT_BALL			0x2e
#define USB_HID_PLAYER				0x2f
#define USB_HID_GUN_BOLT			0x30
#define USB_HID_GUN_CLIP			0x31
#define USB_HID_GUN_SELECTOR			0x32
#define USB_HID_GUN_SINGLE_SHOT			0x33
#define USB_HID_GUN_BURST			0x34
#define USB_HID_GUN_AUTOMATIC			0x35
#define USB_HID_GUN_SAFETY			0x36
#define USB_HID_GAMEPAD_FIRE_JUMP		0x37
#define USB_HID_GAMEPAD_TRIGGER			0x39

/* Generic Device Controls Page */
#define USB_HID_BATTERY_STRENGTH		0x20
#define USB_HID_WIRELESS_CHANNEL		0x21
#define USB_HID_WIRELESS_ID			0x22
#define USB_HID_DISCOVER_WIRELESS_CONTROL	0x23
#define USB_HID_SECURITY_CODE_CHARACTER_ENTERED	0x24
#define USB_HID_SECURITY_CODE_CHARACTER_ERASED	0x25
#define USB_HID_SECURITY_CODE_CLEARED		0x26

/* Keyboard/Keypad Page */
#define USB_HID_KEYBOARD_ERROR_ROLL_OVER	0x01
#define USB_HID_KEYBOARD_POST_FAIL		0x02
#define USB_HID_KEYBOARD_ERROR_UNDEFINED	0x03
#define USB_HID_KEYBOARD_A			0x04 /* a and A */
#define USB_HID_KEYBOARD_B			0x05 /* b and B */
#define USB_HID_KEYBOARD_C			0x06 /* c and C */
#define USB_HID_KEYBOARD_D			0x07 /* d and D */
#define USB_HID_KEYBOARD_E			0x08 /* e and E */
#define USB_HID_KEYBOARD_F			0x09 /* f and F */
#define USB_HID_KEYBOARD_G			0x0a /* g and G */
#define USB_HID_KEYBOARD_H			0x0b /* h and H */
#define USB_HID_KEYBOARD_I			0x0c /* i and I */
#define USB_HID_KEYBOARD_J			0x0d /* j and J */
#define USB_HID_KEYBOARD_K			0x0e /* k and K */
#define USB_HID_KEYBOARD_L			0x0f /* l and L */
#define USB_HID_KEYBOARD_M			0x10 /* m and M */
#define USB_HID_KEYBOARD_N			0x11 /* n and N */
#define USB_HID_KEYBOARD_O			0x12 /* o and O */
#define USB_HID_KEYBOARD_P			0x13 /* p and P */
#define USB_HID_KEYBOARD_Q			0x14 /* q and Q */
#define USB_HID_KEYBOARD_R			0x15 /* r and R */
#define USB_HID_KEYBOARD_S			0x16 /* s and S */
#define USB_HID_KEYBOARD_T			0x17 /* t and T */
#define USB_HID_KEYBOARD_U			0x18 /* u and U */
#define USB_HID_KEYBOARD_V			0x19 /* v and V */
#define USB_HID_KEYBOARD_W			0x1a /* w and W */
#define USB_HID_KEYBOARD_X			0x1b /* x and X */
#define USB_HID_KEYBOARD_Y			0x1c /* y and Y */
#define USB_HID_KEYBOARD_Z			0x1d /* z and Z */
#define USB_HID_KEYBOARD_1			0x1e /* 1 and ! */
#define USB_HID_KEYBOARD_2			0x1f /* 2 and @ */
#define USB_HID_KEYBOARD_3			0x20 /* 3 and # */
#define USB_HID_KEYBOARD_4			0x21 /* 4 and $ */
#define USB_HID_KEYBOARD_5			0x22 /* 5 and % */
#define USB_HID_KEYBOARD_6			0x23 /* 6 and ^ */
#define USB_HID_KEYBOARD_7			0x24 /* 7 and & */
#define USB_HID_KEYBOARD_8			0x25 /* 8 and * */
#define USB_HID_KEYBOARD_9			0x26 /* 9 and ( */
#define USB_HID_KEYBOARD_0			0x27 /* 0 and ) */
#define USB_HID_KEYBOARD_ENTER			0x28 /* Return(ENTER) */
#define USB_HID_KEYBOARD_ESCAPE			0x29
#define USB_HID_KEYBOARD_DELETE			0x2a /* (Backspace) */
#define USB_HID_KEYBOARD_TAB			0x2b
#define USB_HID_KEYBOARD_SPACEBAR		0x2c
#define USB_HID_KEYBOARD_MINUS_SIGN		0x2d /* - and (underscore) */
#define USB_HID_KEYBOARD_EQUAL_SIGN		0x2e /* = and + */
#define USB_HID_KEYBOARD_LEFT_SQUARE_BRACKET	0x2f /* [ and { */
#define USB_HID_KEYBOARD_RIGHT_SQUARE_BRACKET	0x30 /* ] and } */
#define USB_HID_KEYBOARD_BACKSLASH		0x31 /* \ and | */
#define USB_HID_KEYBOARD_NON_US_NUMBER_SIGN	0x32 /* Non-US # and ~ */
#define USB_HID_KEYBOARD_SEMICOLON		0x33 /* ; and : */
#define USB_HID_KEYBOARD_SINGLE_QUOTE		0x34 /* ' and " */
#define USB_HID_KEYBOARD_GRAVE_ACCENT		0x35 /* `and ~ */
#define USB_HID_KEYBOARD_COMMA			0x36 /* , and < */
#define USB_HID_KEYBOARD_PERIOD			0x37 /* . and < */
#define USB_HID_KEYBOARD_SLASH			0x38 /* / and ? */
#define USB_HID_KEYBOARD_CAPS_LOCK		0x39
#define USB_HID_KEYBOARD_F1			0x3a
#define USB_HID_KEYBOARD_F2			0x3b
#define USB_HID_KEYBOARD_F3			0x3c
#define USB_HID_KEYBOARD_F4			0x3d
#define USB_HID_KEYBOARD_F5			0x3e
#define USB_HID_KEYBOARD_F6			0x3f
#define USB_HID_KEYBOARD_F7			0x40
#define USB_HID_KEYBOARD_F8			0x41
#define USB_HID_KEYBOARD_F9			0x42
#define USB_HID_KEYBOARD_F10			0x43
#define USB_HID_KEYBOARD_F11			0x44
#define USB_HID_KEYBOARD_F12			0x45
#define USB_HID_KEYBOARD_PRINT_SCREEN		0x46
#define USB_HID_KEYBOARD_SCROLL_LOCK		0x47
#define USB_HID_KEYBOARD_PAUSE			0x48
#define USB_HID_KEYBOARD_INSERT			0x49
#define USB_HID_KEYBOARD_HOME			0x4a
#define USB_HID_KEYBOARD_PAGE_UP		0x4b
#define USB_HID_KEYBOARD_DELETE_FORWARD		0x4c
#define USB_HID_KEYBOARD_END			0x4d
#define USB_HID_KEYBOARD_PAGE_DOWN		0x4e
#define USB_HID_KEYBOARD_RIGHT_ARROW		0x4f
#define USB_HID_KEYBOARD_LEFT_ARROW		0x50
#define USB_HID_KEYBOARD_DOWN_ARROW		0x51
#define USB_HID_KEYBOARD_UP_ARROW		0x52
#define USB_HID_KEYPAD_NUM_LOCK_AND_CLEAR	0x53
#define USB_HID_KEYPAD_SLASH			0x54
#define USB_HID_KEYPAD_ASTERISK			0x55
#define USB_HID_KEYPAD_MINUS_SIGN		0x56
#define USB_HID_KEYPAD_PLUS_SIGN		0x57
#define USB_HID_KEYPAD_ENTER			0x58
#define USB_HID_KEYPAD_1_AND_END		0x59
#define USB_HID_KEYPAD_2_AND_DOWN_ARROW		0x5a
#define USB_HID_KEYPAD_3_AND_PAGE_DOWN		0x5b
#define USB_HID_KEYPAD_4_AND_LEFT_ARROW		0x5c
#define USB_HID_KEYPAD_5			0x5d
#define USB_HID_KEYPAD_6_AND_RIGHT_ARROW	0x5e
#define USB_HID_KEYPAD_7_AND_HOME		0x5f
#define USB_HID_KEYPAD_8_AND_UP_ARROW		0x60
#define USB_HID_KEYPAD_9_AND_PAGE_UP		0x61
#define USB_HID_KEYPAD_0_AND_INSERT		0x62
#define USB_HID_KEYPAD_PERIOD_AND_DELETE	0x63
#define USB_HID_KEYBOARD_NON_US_BACKSLASH	0x64 /* \ and | */
#define USB_HID_KEYBOARD_APPLICATION		0x65
#define USB_HID_KEYBOARD_POWER			0x66
#define USB_HID_KEYPAD_EQUAL_SIGN		0x67
#define USB_HID_KEYBOARD_F13			0x68
#define USB_HID_KEYBOARD_F14			0x69
#define USB_HID_KEYBOARD_F15			0x6a
#define USB_HID_KEYBOARD_F16			0x6b
#define USB_HID_KEYBOARD_F17			0x6c
#define USB_HID_KEYBOARD_F18			0x6d
#define USB_HID_KEYBOARD_F19			0x6e
#define USB_HID_KEYBOARD_F20			0x6f
#define USB_HID_KEYBOARD_F21			0x70
#define USB_HID_KEYBOARD_F22			0x71
#define USB_HID_KEYBOARD_F23			0x72
#define USB_HID_KEYBOARD_F24			0x73
#define USB_HID_KEYBOARD_EXECUTE		0x74
#define USB_HID_KEYBOARD_HELP			0x75
#define USB_HID_KEYBOARD_MENU			0x76
#define USB_HID_KEYBOARD_SELECT			0x77
#define USB_HID_KEYBOARD_STOP			0x78
#define USB_HID_KEYBOARD_AGAIN			0x79
#define USB_HID_KEYBOARD_UNDO			0x7a
#define USB_HID_KEYBOARD_CUT			0x7b
#define USB_HID_KEYBOARD_COPY			0x7c
#define USB_HID_KEYBOARD_PASTE			0x7d
#define USB_HID_KEYBOARD_FIND			0x7e
#define USB_HID_KEYBOARD_MUTE			0x7f
#define USB_HID_KEYBOARD_VOLUME_UP		0x80
#define USB_HID_KEYBOARD_VOLUME_DOWN		0x81
#define USB_HID_KEYBOARD_LOCKING_CAPS_LOCK	0x82
#define USB_HID_KEYBOARD_LOCKING_NUM_LOCK	0x83
#define USB_HID_KEYBOARD_LOCKING_SCROLL_LOCK	0x84
#define USB_HID_KEYPAD_COMMA			0x85
#define USB_HID_KEYPAD_EQUAL_SIGN_AS400		0x86
#define USB_HID_KEYBOARD_INTERNATIONAL1		0x87
#define USB_HID_KEYBOARD_INTERNATIONAL2		0x88
#define USB_HID_KEYBOARD_INTERNATIONAL3		0x89
#define USB_HID_KEYBOARD_INTERNATIONAL4		0x8a
#define USB_HID_KEYBOARD_INTERNATIONAL5		0x8b
#define USB_HID_KEYBOARD_INTERNATIONAL6		0x8c
#define USB_HID_KEYBOARD_INTERNATIONAL7		0x8d
#define USB_HID_KEYBOARD_INTERNATIONAL8		0x8e
#define USB_HID_KEYBOARD_INTERNATIONAL9		0x8f
#define USB_HID_KEYBOARD_LANG1			0x90
#define USB_HID_KEYBOARD_LANG2			0x91
#define USB_HID_KEYBOARD_LANG3			0x92
#define USB_HID_KEYBOARD_LANG4			0x93
#define USB_HID_KEYBOARD_LANG5			0x94
#define USB_HID_KEYBOARD_LANG6			0x95
#define USB_HID_KEYBOARD_LANG7			0x96
#define USB_HID_KEYBOARD_LANG8			0x97
#define USB_HID_KEYBOARD_LANG9			0x98
#define USB_HID_KEYBOARD_ALTERNATE_ERASE	0x99
#define USB_HID_KEYBOARD_SYSREQ_ATTENTION	0x9a
#define USB_HID_KEYBOARD_CANCEL			0x9b
#define USB_HID_KEYBOARD_CLEAR			0x9c
#define USB_HID_KEYBOARD_PRIOR			0x9d
#define USB_HID_KEYBOARD_RETURN			0x9e
#define USB_HID_KEYBOARD_SEPARATOR		0x9f
#define USB_HID_KEYBOARD_OUT			0xa0
#define USB_HID_KEYBOARD_OPER			0xa1
#define USB_HID_KEYBOARD_CLEAR_AGAIN		0xa2
#define USB_HID_KEYBOARD_CRSEL_PROPS		0xa3
#define USB_HID_KEYBOARD_EXSEL			0xa4
#define USB_HID_KEYPAD_00			0xb0
#define USB_HID_KEYPAD_000			0xb1
#define USB_HID_THOUSANDS_SEPARATOR		0xb2
#define USB_HID_DECIMAL_SEPARATOR		0xb3
#define USB_HID_CURRENCY_UNIT			0xb4
#define USB_HID_CURRENCY_SUB_UNIT		0xb5
#define USB_HID_KEYPAD_LEFT_PARENTHESIS		0xb6 /* ( */
#define USB_HID_KEYPAD_RIGHT_PARENTHESIS	0xb7 /* ) */
#define USB_HID_KEYPAD_LEFT_CURLY_BRACKET	0xb8 /* { */
#define USB_HID_KEYPAD_RIGHT_CURLY_BRACKET	0xb9 /* } */
#define USB_HID_KEYPAD_TAB			0xba
#define USB_HID_KEYPAD_BACKSPACE		0xbb
#define USB_HID_KEYPAD_A			0xbc
#define USB_HID_KEYPAD_B			0xbd
#define USB_HID_KEYPAD_C			0xbe
#define USB_HID_KEYPAD_D			0xbf
#define USB_HID_KEYPAD_E			0xc0
#define USB_HID_KEYPAD_F			0xc1
#define USB_HID_KEYPAD_XOR			0xc2
#define USB_HID_KEYPAD_CARET			0xc3 /* ^ */
#define USB_HID_KEYPAD_PERCENT_SIGN		0xc4 /* % */
#define USB_HID_KEYPAD_LESS_THAN_SIGN		0xc5 /* < */
#define USB_HID_KEYPAD_GREATER_THAN_SIGN	0xc6 /* > */
#define USB_HID_KEYPAD_AMPERSAND		0xc7 /* & */
#define USB_HID_KEYPAD_DOUBLE_AMPERSAND		0xc8 /* && */
#define USB_HID_KEYPAD_VERTICAL_BAR		0xc9 /* | */
#define USB_HID_KEYPAD_DOUBLE_VERTICAL_BAR	0xca /* || */
#define USB_HID_KEYPAD_COLON			0xcb /* : */
#define USB_HID_KEYPAD_NUMBER_SIGN		0xcc /* # */
#define USB_HID_KEYPAD_SPACE			0xcd
#define USB_HID_KEYPAD_COMMERCIAL_AT_SIGN	0xce /* @ */
#define USB_HID_KEYPAD_EXCLAMATION_MARK		0xcf /* ! */
#define USB_HID_KEYPAD_MEMORY_STORE		0xd0
#define USB_HID_KEYPAD_MEMORY_RECALL		0xd1
#define USB_HID_KEYPAD_MEMORY_CLEAR		0xd2
#define USB_HID_KEYPAD_MEMORY_ADD		0xd3
#define USB_HID_KEYPAD_MEMORY_SUBTRACT		0xd4
#define USB_HID_KEYPAD_MEMORY_MULTIPLY		0xd5
#define USB_HID_KEYPAD_MEMORY_DIVIDE		0xd6
#define USB_HID_KEYPAD_PLUS_MINUS		0xd7 /* +/- */
#define USB_HID_KEYPAD_CLEAR			0xd8
#define USB_HID_KEYPAD_CLEAR_ENTRY		0xd9
#define USB_HID_KEYPAD_BINARY			0xda
#define USB_HID_KEYPAD_OCTAL			0xdb
#define USB_HID_KEYPAD_DECIMAL			0xdc
#define USB_HID_KEYPAD_HEXADECIMAL		0xdd
#define USB_HID_KEYBOARD_LEFT_CONTROL		0xe0
#define USB_HID_KEYBOARD_LEFT_SHIFT		0xe1
#define USB_HID_KEYBOARD_LEFT_ALT		0xe2
#define USB_HID_KEYBOARD_LEFT_GUI		0xe3
#define USB_HID_KEYBOARD_RIGHT_CONTROL		0xe4
#define USB_HID_KEYBOARD_RIGHT_SHIFT		0xe5
#define USB_HID_KEYBOARD_RIGHT_ALT		0xe6
#define USB_HID_KEYBOARD_RIGHT_GUI		0xe7

/* LED Page */
#define USB_HID_LED_NUM_LOCK			0x01
#define USB_HID_LED_CAPS_LOCK			0x02
#define USB_HID_LED_SCROLL_LOCK			0x03
#define USB_HID_LED_COMPOSE			0x04
#define USB_HID_LED_KANA			0x05
#define USB_HID_LED_POWER			0x06
#define USB_HID_LED_SHIFT			0x07
#define USB_HID_LED_DO_NOT_DISTURB		0x08
#define USB_HID_LED_MUTE			0x09
#define USB_HID_LED_TONE_ENABLE			0x0a
#define USB_HID_LED_HIGH_CUT_FILTER		0x0b
#define USB_HID_LED_LOW_CUT_FILTER		0x0c
#define USB_HID_LED_EQUALIZER_ENABLE		0x0d
#define USB_HID_LED_SOUND_FIELD_ON		0x0e
#define USB_HID_LED_SURROUND_ON			0x0f
#define USB_HID_LED_REPEAT			0x10
#define USB_HID_LED_STEREO			0x11
#define USB_HID_LED_SAMPLING_RATE_DETECT	0x12
#define USB_HID_LED_SPINNING			0x13
#define USB_HID_LED_CAV				0x14
#define USB_HID_LED_CLV				0x15
#define USB_HID_LED_RECORDING_FORMAT_DETECT	0x16
#define USB_HID_LED_OFF_HOOK			0x17
#define USB_HID_LED_RING			0x18
#define USB_HID_LED_MESSAGE_WAITING		0x19
#define USB_HID_LED_DATA_MODE			0x1a
#define USB_HID_LED_BATTERY_OPERATION		0x1b
#define USB_HID_LED_BATTERY_OK			0x1c
#define USB_HID_LED_BATTERY_LOW			0x1d
#define USB_HID_LED_SPEAKER			0x1e
#define USB_HID_LED_HEAD_SET			0x1f
#define USB_HID_LED_HOLD			0x20
#define USB_HID_LED_MICROPHONE			0x21
#define USB_HID_LED_COVERAGE			0x22
#define USB_HID_LED_NIGHT_MODE			0x23
#define USB_HID_LED_SEND_CALLS			0x24
#define USB_HID_LED_CALL_PICKUP			0x25
#define USB_HID_LED_CONFERENCE			0x26
#define USB_HID_LED_STAND_BY			0x27
#define USB_HID_LED_CAMERA_ON			0x28
#define USB_HID_LED_CAMERA_OFF			0x29
#define USB_HID_LED_ON_LINE			0x2a
#define USB_HID_LED_OFF_LINE			0x2b
#define USB_HID_LED_BUSY			0x2c
#define USB_HID_LED_READY			0x2d
#define USB_HID_LED_PAPER_OUT			0x2e
#define USB_HID_LED_PAPER_JAM			0x2f
#define USB_HID_LED_REMOTE			0x30
#define USB_HID_LED_FORWARD			0x31
#define USB_HID_LED_REVERSE			0x32
#define USB_HID_LED_STOP			0x33
#define USB_HID_LED_REWIND			0x34
#define USB_HID_LED_FAST_FORWARD		0x35
#define USB_HID_LED_PLAY			0x36
#define USB_HID_LED_PAUSE			0x37
#define USB_HID_LED_RECORD			0x38
#define USB_HID_LED_ERROR			0x39
#define USB_HID_LED_USAGE_SELECTED_INDICATOR	0x3a
#define USB_HID_LED_USAGE_IN_USE_INDICATOR	0x3b
#define USB_HID_LED_USAGE_MULTI_MODE_INDICATOR	0x3c
#define USB_HID_LED_INDICATOR_ON		0x3d
#define USB_HID_LED_INDICATOR_FLASH		0x3e
#define USB_HID_LED_INDICATOR_SLOW_BLINK	0x3f
#define USB_HID_LED_INDICATOR_FAST_BLINK	0x40
#define USB_HID_LED_INDICATOR_OFF		0x41
#define USB_HID_LED_FLASH_ON_TIME		0x42
#define USB_HID_LED_SLOW_BLINK_ON_TIME		0x43
#define USB_HID_LED_SLOW_BLINK_OFF_TIME		0x44
#define USB_HID_LED_FAST_BLINK_ON_TIME		0x45
#define USB_HID_LED_FAST_BLINK_OFF_TIME		0x46
#define USB_HID_LED_USAGE_INDICATOR_COLOR	0x47
#define USB_HID_LED_INDICATOR_RED		0x48
#define USB_HID_LED_INDICATOR_GREEN		0x49
#define USB_HID_LED_INDICATOR_AMBER		0x4a
#define USB_HID_LED_GENERIC_INDICATOR		0x4b
#define USB_HID_LED_SYSTEM_SUSPEND		0x4c
#define USB_HID_LED_EXTERNAL_POWER_CONNECTED	0x4d

/* Button Page */
#define USB_HID_BUTTON(n)			n

/* Ordinal Page */
#define USB_HID_INSTANCE(n)			n

/* Telephony Device Page */
#define USB_HID_PHONE				0x01
#define USB_HID_ANSWERING_MACHINE		0x02
#define USB_HID_MESSAGE_CONTROLS		0x03
#define USB_HID_HANDSET				0x04
#define USB_HID_HEADSET				0x05
#define USB_HID_TELEPHONY_KEY_PAD		0x06
#define USB_HID_PROGRAMMABLE_BUTTON		0x07
#define USB_HID_HOOK_SWITCH			0x20
#define USB_HID_FLASH				0x21
#define USB_HID_TELEPHONY_FEATURE		0x22
#define USB_HID_HOLD				0x23
#define USB_HID_REDIAL				0x24
#define USB_HID_TRANSFER			0x25
#define USB_HID_DROP				0x26
#define USB_HID_PARK				0x27
#define USB_HID_FORWARD_CALLS			0x28
#define USB_HID_ALTERNATE_FUNCTION		0x29
#define USB_HID_LINE				0x2a
#define USB_HID_SPEAKER_PHONE			0x2b
#define USB_HID_CONFERENCE			0x2c
#define USB_HID_RING_ENABLE			0x2d
#define USB_HID_RING_SELECT			0x2e
#define USB_HID_PHONE_MUTE			0x2f
#define USB_HID_CALLER_ID			0x30
#define USB_HID_SEND				0x31
#define USB_HID_SPEED_DIAL			0x50
#define USB_HID_STORE_NUMBER			0x51
#define USB_HID_RECALL_NUMBER			0x52
#define USB_HID_PHONE_DIRECTORY			0x53
#define USB_HID_VOICE_MAIL			0x70
#define USB_HID_SCREEN_CALLS			0x71
#define USB_HID_DO_NOT_DISTURB			0x72
#define USB_HID_MESSAGE				0x73
#define USB_HID_ANSWER_ON_OFF			0x74
#define USB_HID_INSIDE_DIAL_TONE		0x90
#define USB_HID_OUTSIDE_DIAL_TONE		0x91
#define USB_HID_INSIDE_RING_TONE		0x92
#define USB_HID_OUTSIDE_RING_TONE		0x93
#define USB_HID_PRIORITY_RING_TONE		0x94
#define USB_HID_INSIDE_RINGBACK			0x95
#define USB_HID_PRIORITY_RINGBACK		0x96
#define USB_HID_LINE_BUSY_TONE			0x97
#define USB_HID_REORDER_TONE			0x98
#define USB_HID_CALL_WAITING_TONE		0x99
#define USB_HID_CONFIRMATION_TONE_1		0x9a
#define USB_HID_CONFIRMATION_TONE_2		0x9b
#define USB_HID_TONES_OFF			0x9c
#define USB_HID_OUTSIDE_RINGBACK		0x9d
#define USB_HID_RINGER				0x9e
#define USB_HID_PHONE_KEY_0			0xb0
#define USB_HID_PHONE_KEY_1			0xb1
#define USB_HID_PHONE_KEY_2			0xb2
#define USB_HID_PHONE_KEY_3			0xb3
#define USB_HID_PHONE_KEY_4			0xb4
#define USB_HID_PHONE_KEY_5			0xb5
#define USB_HID_PHONE_KEY_6			0xb6
#define USB_HID_PHONE_KEY_7			0xb7
#define USB_HID_PHONE_KEY_8			0xb8
#define USB_HID_PHONE_KEY_9			0xb9
#define USB_HID_PHONE_KEY_STAR			0xba
#define USB_HID_PHONE_KEY_POUND			0xbb
#define USB_HID_PHONE_KEY_A			0xbc
#define USB_HID_PHONE_KEY_B			0xbd
#define USB_HID_PHONE_KEY_C			0xbe
#define USB_HID_PHONE_KEY_D			0xbf

/* Consumer Page */
#define USB_HID_CONSUMER_CONTROL		0x01
#define USB_HID_NUMERIC_KEY_PAD			0x02
#define USB_HID_PROGRAMMABLE_BUTTONS		0x03
#define USB_HID_MICROPHONE			0x04
#define USB_HID_HEADPHONE			0x05
#define USB_HID_GRAPHIC_EQUALIZER		0x06
#define USB_HID_PLUS10				0x20
#define USB_HID_PLUS100				0x21
#define USB_HID_AM_PM				0x22
#define USB_HID_POWER				0x30
#define USB_HID_RESET				0x31
#define USB_HID_SLEEP				0x32
#define USB_HID_SLEEP_AFTER			0x33
#define USB_HID_SLEEP_MODE			0x34
#define USB_HID_ILLUMINATION			0x35
#define USB_HID_FUNCTION_BUTTONS		0x36
#define USB_HID_MENU				0x40
#define USB_HID_MENU_PICK			0x41
#define USB_HID_MENU_UP				0x42
#define USB_HID_MENU_DOWN			0x43
#define USB_HID_MENU_LEFT			0x44
#define USB_HID_MENU_RIGHT			0x45
#define USB_HID_MENU_ESCAPE			0x46
#define USB_HID_MENU_VALUE_INCREASE		0x47
#define USB_HID_MENU_VALUE_DECREASE		0x48
#define USB_HID_DATA_ON_SCREEN			0x60
#define USB_HID_CLOSED_CAPTION			0x61
#define USB_HID_CLOSED_CAPTION_SELECT		0x62
#define USB_HID_VCR_TV				0x63
#define USB_HID_BROADCAST_MODE			0x64
#define USB_HID_SNAPSHOT			0x65
#define USB_HID_STILL				0x66
#define USB_HID_SELECTION			0x80
#define USB_HID_ASSIGN_SELECTION		0x81
#define USB_HID_MODE_STEP			0x82
#define USB_HID_RECALL_LAST			0x83
#define USB_HID_ENTER_CHANNEL			0x84
#define USB_HID_ORDER_MOVIE			0x85
#define USB_HID_CHANNEL				0x86
#define USB_HID_MEDIA_SELECTION			0x87
#define USB_HID_MEDIA_SELECT_COMPUTER		0x88
#define USB_HID_MEDIA_SELECT_TV			0x89
#define USB_HID_MEDIA_SELECT_WWW		0x8a
#define USB_HID_MEDIA_SELECT_DVD		0x8b
#define USB_HID_MEDIA_SELECT_TELEPHONE		0x8c
#define USB_HID_MEDIA_SELECT_PROGRAM_GUIDE	0x8d
#define USB_HID_MEDIA_SELECT_VIDEO_PHONE	0x8e
#define USB_HID_MEDIA_SELECT_GAMES		0x8f
#define USB_HID_MEDIA_SELECT_MESSAGES		0x90
#define USB_HID_MEDIA_SELECT_CD			0x91
#define USB_HID_MEDIA_SELECT_VCR		0x92
#define USB_HID_MEDIA_SELECT_TUNER		0x93
#define USB_HID_QUIT				0x94
#define USB_HID_HELP				0x95
#define USB_HID_MEDIA_SELECT_TAPE		0x96
#define USB_HID_MEDIA_SELECT_CABLE		0x97
#define USB_HID_MEDIA_SELECT_SATELLITE		0x98
#define USB_HID_MEDIA_SELECT_SECURITY		0x99
#define USB_HID_MEDIA_SELECT_HOME		0x9a
#define USB_HID_MEDIA_SELECT_CALL		0x9b
#define USB_HID_CHANNEL_INCREMENT		0x9c
#define USB_HID_CHANNEL_DECREMENT		0x9d
#define USB_HID_MEDIA_SELECT_SAP		0x9e
#define USB_HID_VCR_PLUS			0xa0
#define USB_HID_ONCE				0xa1
#define USB_HID_DAILY				0xa2
#define USB_HID_WEEKLY				0xa3
#define USB_HID_MONTHLY				0xa4
#define USB_HID_PLAY				0xb0
#define USB_HID_PAUSE				0xb1
#define USB_HID_RECORD				0xb2
#define USB_HID_FAST_FORWARD			0xb3
#define USB_HID_REWIND				0xb4
#define USB_HID_SCAN_NEXT_TRACK			0xb5
#define USB_HID_SCAN_PREVIOUS_TRACK		0xb6
#define USB_HID_STOP				0xb7
#define USB_HID_EJECT				0xb8
#define USB_HID_RANDOM_PLAY			0xb9
#define USB_HID_SELECT_DISC			0xba
#define USB_HID_ENTER_DISC			0xbb
#define USB_HID_REPEAT				0xbc
#define USB_HID_TRACKING			0xbd
#define USB_HID_TRACK_NORMAL			0xbe
#define USB_HID_SLOW_TRACKING			0xbf
#define USB_HID_FRAME_FORWARD			0xc0
#define USB_HID_FRAME_BACK			0xc1
#define USB_HID_MARK				0xc2
#define USB_HID_CLEAR_MARK			0xc3
#define USB_HID_REPEAT_FROM_MARK		0xc4
#define USB_HID_RETURN_TO_MARK			0xc5
#define USB_HID_SEARCH_MARK_FORWARD		0xc6
#define USB_HID_SEARCH_MARK_BACKWARDS		0xc7
#define USB_HID_COUNTER_RESET			0xc8
#define USB_HID_SHOW_COUNTER			0xc9
#define USB_HID_TRACKING_INCREMENT		0xca
#define USB_HID_TRACKING_DECREMENT		0xcb
#define USB_HID_STOP_EJECT			0xcc
#define USB_HID_PLAY_PAUSE			0xcd
#define USB_HID_PLAY_SKIP			0xce
#define USB_HID_VOLUME				0xe0
#define USB_HID_BALANCE				0xe1
#define USB_HID_MUTE				0xe2
#define USB_HID_BASS				0xe3
#define USB_HID_TREBLE				0xe4
#define USB_HID_BASS_BOOST			0xe5
#define USB_HID_SURROUND_MODE			0xe6
#define USB_HID_LOUDNESS			0xe7
#define USB_HID_MPX				0xe8
#define USB_HID_VOLUME_INCREMENT		0xe9
#define USB_HID_VOLUME_DECREMENT		0xea
#define USB_HID_SPEED_SELECT			0xf0
#define USB_HID_PLAYBACK_SPEED			0xf1
#define USB_HID_STANDARD_PLAY			0xf2
#define USB_HID_LONG_PLAY			0xf3
#define USB_HID_EXTENDED_PLAY			0xf4
#define USB_HID_SLOW				0xf5
#define USB_HID_FAN_ENABLE			0x100
#define USB_HID_FAN_SPEED			0x101
#define USB_HID_LIGHT_ENABLE			0x102
#define USB_HID_LIGHT_ILLUMINATION_LEVEL	0x103
#define USB_HID_CLIMATE_CONTROL_ENABLE		0x104
#define USB_HID_ROOM_TEMPERATURE		0x105
#define USB_HID_SECURITY_ENABLE			0x106
#define USB_HID_FIRE_ALARM			0x107
#define USB_HID_POLICE_ALARM			0x108
#define USB_HID_PROXIMITY			0x109
#define USB_HID_MOTION				0x10a
#define USB_HID_DURESS_ALARM			0x10b
#define USB_HID_HOLDUP_ALARM			0x10c
#define USB_HID_MEDICAL_ALARM			0x10d
#define USB_HID_BALANCE_RIGHT			0x150
#define USB_HID_BALANCE_LEFT			0x151
#define USB_HID_BASS_INCREMENT			0x152
#define USB_HID_BASS_DECREMENT			0x153
#define USB_HID_TREBLE_INCREMENT		0x154
#define USB_HID_TREBLE_DECREMENT		0x155
#define USB_HID_SPEAKER_SYSTEM			0x160
#define USB_HID_CHANNEL_LEFT			0x161
#define USB_HID_CHANNEL_RIGHT			0x162
#define USB_HID_CHANNEL_CENTER			0x163
#define USB_HID_CHANNEL_FRONT			0x164
#define USB_HID_CHANNEL_CENTER_FRONT		0x165
#define USB_HID_CHANNEL_SIDE			0x166
#define USB_HID_CHANNEL_SURROUND		0x167
#define USB_HID_CHANNEL_LOW_FREQ_ENHANCEMENT	0x168
#define USB_HID_CHANNEL_TOP			0x169
#define USB_HID_CHANNEL_UNKNOWN			0x16a
#define USB_HID_SUB_CHANNEL			0x170
#define USB_HID_SUB_CHANNEL_INCREMENT		0x171
#define USB_HID_SUB_CHANNEL_DECREMENT		0x172
#define USB_HID_ALTERNATE_AUDIO_INCREMENT	0x173
#define USB_HID_ALTERNATE_AUDIO_DECREMENT	0x174
#define USB_HID_APPLICATION_LAUNCH_BUTTONS	0x180
#define USB_HID_AL_LAUNCH_BUTTON_CONFIG_TOOL	0x181
#define USB_HID_AL_PROGRAMMABLE_BUTTON_CONFIG	0x182
#define USB_HID_AL_CONSUMER_CONTROL_CONFIG	0x183
#define USB_HID_AL_WORD_PROCESSOR		0x184
#define USB_HID_AL_TEXT_EDITOR			0x185
#define USB_HID_AL_SPREADSHEET			0x186
#define USB_HID_AL_GRAPHICS_EDITOR		0x187
#define USB_HID_AL_PRESENTATION_APP		0x188
#define USB_HID_AL_DATABASE_APP			0x189
#define USB_HID_AL_EMAIL_READER			0x18a
#define USB_HID_AL_NEWSREADER			0x18b
#define USB_HID_AL_VOICEMAIL			0x18c
#define USB_HID_AL_CONTACTS_ADDRESS_BOOK	0x18d
#define USB_HID_AL_CALENDAR_SCHEDULE		0x18e
#define USB_HID_AL_TASK_PROJECT_MANAGER		0x18f
#define USB_HID_AL_LOG_JOURNAL_TIMECARD		0x190
#define USB_HID_AL_CHECKBOOK_FINANCE		0x191
#define USB_HID_AL_CALCULATOR			0x192
#define USB_HID_AL_AV_CAPTURE_PLAYBACK		0x193
#define USB_HID_AL_LOCAL_MACHINE_BROWSER	0x194
#define USB_HID_AL_LAN_WAN_BROWSER		0x195
#define USB_HID_AL_INTERNET_BROWSER		0x196
#define USB_HID_AL_REMOTE_NETWORK_ISP_CONNECT	0x197
#define USB_HID_AL_NETWORK_CONFERENCE		0x198
#define USB_HID_AL_NETWORK_CHAT			0x199
#define USB_HID_AL_TELEPHONY_DIALER		0x19a
#define USB_HID_AL_LOGON			0x19b
#define USB_HID_AL_LOGOFF			0x19c
#define USB_HID_AL_LOGON_LOGOFF			0x19d
#define USB_HID_AL_TERMINAL_LOCK_SCREENSAVER	0x19e
#define USB_HID_AL_CONTROL_PANEL		0x19f
#define USB_HID_AL_COMMAND_LINE_PROCESSOR_RUN	0x1a0
#define USB_HID_AL_PROCESS_TASK_MANAGER		0x1a1
#define USB_HID_AL_SELECT_TASK_APPLICATION	0x1a2
#define USB_HID_AL_NEXT_TASK_APPLICATION	0x1a3
#define USB_HID_AL_PREVIOUS_TASK_APPLICATION	0x1a4
#define USB_HID_AL_PREEMPTIVE_HALT_TASK_APP	0x1a5
#define USB_HID_AL_INTEGRATED_HELP_CENTER	0x1a6
#define USB_HID_AL_DOCUMENTS			0x1a7
#define USB_HID_AL_THESAURUS			0x1a8
#define USB_HID_AL_DICTIONARY			0x1a9
#define USB_HID_AL_DESKTOP			0x1aa
#define USB_HID_AL_SPELL_CHECK			0x1ab
#define USB_HID_AL_GRAMMAR_CHECK		0x1ac
#define USB_HID_AL_WIRELESS_STATUS		0x1ad
#define USB_HID_AL_KEYBOARD_LAYOUT		0x1ae
#define USB_HID_AL_VIRUS_PROTECTION		0x1af
#define USB_HID_AL_ENCRYPTION			0x1b0
#define USB_HID_AL_SCREEN_SAVER			0x1b1
#define USB_HID_AL_ALARMS			0x1b2
#define USB_HID_AL_CLOCK			0x1b3
#define USB_HID_AL_FILE_BROWSER			0x1b4
#define USB_HID_AL_POWER_STATUS			0x1b5
#define USB_HID_AL_IMAGE_BROWSER		0x1b6
#define USB_HID_AL_AUDIO_BROWSER		0x1b7
#define USB_HID_AL_MOVIE_BROWSER		0x1b8
#define USB_HID_AL_DIGITAL_RIGHTS_MANAGER	0x1b9
#define USB_HID_AL_DIGITAL_WALLET		0x1ba
#define USB_HID_AL_INSTANT_MESSAGING		0x1bc
#define USB_HID_AL_OEM_FEATURES_TIPS_BROWSER	0x1bd
#define USB_HID_AL_OEM_HELP			0x1be
#define USB_HID_AL_ONLINE_COMMUNITY		0x1bf
#define USB_HID_AL_ENTERTAINMENT_CONT_BROWSER	0x1c0
#define USB_HID_AL_ONLINE_SHOPPING_BROWSER	0x1c1
#define USB_HID_AL_SMARTCARD_INFORMATION_HELP	0x1c2
#define USB_HID_AL_MARKET_MONITOR_BROWSER	0x1c3
#define USB_HID_AL_CUSTOMIZED_CORP_NEWS_BROWSER	0x1c4
#define USB_HID_AL_ONLINE_ACTIVITY_BROWSER	0x1c5
#define USB_HID_AL_RESEARCH_SEARCH_BROWSER	0x1c6
#define USB_HID_AL_AUDIO_PLAYER			0x1c7
#define USB_HID_GENERIC_GUI_APP_CONTROLS	0x200
#define USB_HID_AC_NEW				0x201
#define USB_HID_AC_OPEN				0x202
#define USB_HID_AC_CLOSE			0x203
#define USB_HID_AC_EXIT				0x204
#define USB_HID_AC_MAXIMIZE			0x205
#define USB_HID_AC_MINIMIZE			0x206
#define USB_HID_AC_SAVE				0x207
#define USB_HID_AC_PRINT			0x208
#define USB_HID_AC_PROPERTIES			0x209
#define USB_HID_AC_UNDO				0x21a
#define USB_HID_AC_COPY				0x21b
#define USB_HID_AC_CUT				0x21c
#define USB_HID_AC_PASTE			0x21d
#define USB_HID_AC_SELECT_ALL			0x21e
#define USB_HID_AC_FIND				0x21f
#define USB_HID_AC_FIND_AND_REPLACE		0x220
#define USB_HID_AC_SEARCH			0x221
#define USB_HID_AC_GO_TO			0x222
#define USB_HID_AC_HOME				0x223
#define USB_HID_AC_BACK				0x224
#define USB_HID_AC_FORWARD			0x225
#define USB_HID_AC_STOP				0x226
#define USB_HID_AC_REFRESH			0x227
#define USB_HID_AC_PREVIOUS_LINK		0x228
#define USB_HID_AC_NEXT_LINK			0x229
#define USB_HID_AC_BOOKMARKS			0x22a
#define USB_HID_AC_HISTORY			0x22b
#define USB_HID_AC_SUBSCRIPTIONS		0x22c
#define USB_HID_AC_ZOOM_IN			0x22d
#define USB_HID_AC_ZOOM_OUT			0x22e
#define USB_HID_AC_ZOOM				0x22f
#define USB_HID_AC_FULL_SCREEN_VIEW		0x230
#define USB_HID_AC_NORMAL_VIEW			0x231
#define USB_HID_AC_VIEW_TOGGLE			0x232
#define USB_HID_AC_SCROLL_UP			0x233
#define USB_HID_AC_SCROLL_DOWN			0x234
#define USB_HID_AC_SCROLL			0x235
#define USB_HID_AC_PAN_LEFT			0x236
#define USB_HID_AC_PAN_RIGHT			0x237
#define USB_HID_AC_PAN				0x238
#define USB_HID_AC_NEW_WINDOW			0x239
#define USB_HID_AC_TILE_HORIZONTALLY		0x23a
#define USB_HID_AC_TILE_VERTICALLY		0x23b
#define USB_HID_AC_FORMAT			0x23c
#define USB_HID_AC_EDIT				0x23d
#define USB_HID_AC_BOLD				0x23e
#define USB_HID_AC_ITALICS			0x23f
#define USB_HID_AC_UNDERLINE			0x240
#define USB_HID_AC_STRIKETHROUGH		0x241
#define USB_HID_AC_SUBSCRIPT			0x242
#define USB_HID_AC_SUPERSCRIPT			0x243
#define USB_HID_AC_ALL_CAPS			0x244
#define USB_HID_AC_ROTATE			0x245
#define USB_HID_AC_RESIZE			0x246
#define USB_HID_AC_FLIP_HORIZONTAL		0x247
#define USB_HID_AC_FLIP_VERTICAL		0x248
#define USB_HID_AC_MIRROR_HORIZONTAL		0x249
#define USB_HID_AC_MIRROR_VERTICAL		0x24a
#define USB_HID_AC_FONT_SELECT			0x24b
#define USB_HID_AC_FONT_COLOR			0x24c
#define USB_HID_AC_FONT_SIZE			0x24d
#define USB_HID_AC_JUSTIFY_LEFT			0x24e
#define USB_HID_AC_JUSTIFY_CENTER_H		0x24f
#define USB_HID_AC_JUSTIFY_RIGHT		0x250
#define USB_HID_AC_JUSTIFY_BLOCK_H		0x251
#define USB_HID_AC_JUSTIFY_TOP			0x252
#define USB_HID_AC_JUSTIFY_CENTER_V		0x253
#define USB_HID_AC_JUSTIFY_BOTTOM		0x254
#define USB_HID_AC_JUSTIFY_BLOCK_V		0x255
#define USB_HID_AC_INDENT_DECREASE		0x256
#define USB_HID_AC_INDENT_INCREASE		0x257
#define USB_HID_AC_NUMBERED_LIST		0x258
#define USB_HID_AC_RESTART_NUMBERING		0x259
#define USB_HID_AC_BULLETED_LIST		0x25a
#define USB_HID_AC_PROMOTE			0x25b
#define USB_HID_AC_DEMOTE			0x25c
#define USB_HID_AC_YES				0x25d
#define USB_HID_AC_NO				0x25e
#define USB_HID_AC_CANCEL			0x25f
#define USB_HID_AC_CATALOG			0x260
#define USB_HID_AC_BUY_CHECKOUT			0x261
#define USB_HID_AC_ADD_TO_CART			0x262
#define USB_HID_AC_EXPAND			0x263
#define USB_HID_AC_EXPAND_ALL			0x264
#define USB_HID_AC_COLLAPSE			0x265
#define USB_HID_AC_COLLAPSE_ALL			0x266
#define USB_HID_AC_PRINT_PREVIEW		0x267
#define USB_HID_AC_PASTE_SPECIAL		0x268
#define USB_HID_AC_INSERT_MODE			0x269
#define USB_HID_AC_DELETE			0x26a
#define USB_HID_AC_LOCK				0x26b
#define USB_HID_AC_UNLOCK			0x26c
#define USB_HID_AC_PROTECT			0x26d
#define USB_HID_AC_UNPROTECT			0x26e
#define USB_HID_AC_ATTACH_COMMENT		0x26f
#define USB_HID_AC_DELETE_COMMENT		0x270
#define USB_HID_AC_VIEW_COMMENT			0x271
#define USB_HID_AC_SELECT_WORD			0x272
#define USB_HID_AC_SELECT_SENTENCE		0x273
#define USB_HID_AC_SELECT_PARAGRAPH		0x274
#define USB_HID_AC_SELECT_COLUMN		0x275
#define USB_HID_AC_SELECT_ROW			0x276
#define USB_HID_AC_SELECT_TABLE			0x277
#define USB_HID_AC_SELECT_OBJECT		0x278
#define USB_HID_AC_REDO_REPEAT			0x279
#define USB_HID_AC_SORT				0x27a
#define USB_HID_AC_SORT_ASCENDING		0x27b
#define USB_HID_AC_SORT_DESCENDING		0x27c
#define USB_HID_AC_FILTER			0x27d
#define USB_HID_AC_SET_CLOCK			0x27e
#define USB_HID_AC_VIEW_CLOCK			0x27f
#define USB_HID_AC_SELECT_TIME_ZONE		0x280
#define USB_HID_AC_EDIT_TIME_ZONES		0x281
#define USB_HID_AC_SET_ALARM			0x282
#define USB_HID_AC_CLEAR_ALARM			0x283
#define USB_HID_AC_SNOOZE_ALARM			0x284
#define USB_HID_AC_RESET_ALARM			0x285
#define USB_HID_AC_SYNCHRONIZE			0x286
#define USB_HID_AC_SEND_RECEIVE			0x287
#define USB_HID_AC_SEND_TO			0x288
#define USB_HID_AC_REPLY			0x289
#define USB_HID_AC_REPLY_ALL			0x28a
#define USB_HID_AC_FORWARD_MSG			0x28b
#define USB_HID_AC_SEND				0x28c
#define USB_HID_AC_ATTACH_FILE			0x28d
#define USB_HID_AC_UPLOAD			0x28e
#define USB_HID_AC_DOWNLOAD			0x28f
#define USB_HID_AC_SET_BORDERS			0x290
#define USB_HID_AC_INSERT_ROW			0x291
#define USB_HID_AC_INSERT_COLUMN		0x292
#define USB_HID_AC_INSERT_FILE			0x293
#define USB_HID_AC_INSERT_PICTURE		0x294
#define USB_HID_AC_INSERT_OBJECT		0x295
#define USB_HID_AC_INSERT_SYMBOL		0x296
#define USB_HID_AC_SAVE_AND_CLOSE		0x297
#define USB_HID_AC_RENAME			0x298
#define USB_HID_AC_MERGE			0x299
#define USB_HID_AC_SPLIT			0x29a
#define USB_HID_AC_DISTRIBUTE_HORIZONTALLY	0x29b
#define USB_HID_AC_DISTRIBUTE_VERTICALLY	0x29c

/* Digitizers */
#define USB_HID_DIGITIZER			0x01
#define USB_HID_PEN				0x02
#define USB_HID_LIGHT_PEN			0x03
#define USB_HID_TOUCH_SCREEN			0x04
#define USB_HID_TOUCH_PAD			0x05
#define USB_HID_WHITE_BOARD			0x06
#define USB_HID_COORDINATE_MEASURING_MACHINE	0x07
#define USB_HID_3D_DIGITIZER			0x08
#define USB_HID_STEREO_PLOTTER			0x09
#define USB_HID_ARTICULATED_ARM			0x0a
#define USB_HID_ARMATURE			0x0b
#define USB_HID_MULTIPLE_POINT_DIGITIZER	0x0c
#define USB_HID_FREE_SPACE_WAND			0x0d
#define USB_HID_STYLUS				0x20
#define USB_HID_PUCK				0x21
#define USB_HID_FINGER				0x22
#define USB_HID_TIP_PRESSURE			0x30
#define USB_HID_BARREL_PRESSURE			0x31
#define USB_HID_IN_RANGE			0x32
#define USB_HID_TOUCH				0x33
#define USB_HID_UNTOUCH				0x34
#define USB_HID_TAP				0x35
#define USB_HID_QUALITY				0x36
#define USB_HID_DATA_VALID			0x37
#define USB_HID_TRANSDUCER_INDEX		0x38
#define USB_HID_TABLET_FUNCTION_KEYS		0x39
#define USB_HID_PROGRAM_CHANGE_KEYS		0x3a
#define USB_HID_DIGITIZER_BATTERY_STRENGTH	0x3b
#define USB_HID_INVERT				0x3c
#define USB_HID_X_TILT				0x3d
#define USB_HID_Y_TILT				0x3e
#define USB_HID_AZIMUTH				0x3f
#define USB_HID_ALTITUDE			0x40
#define USB_HID_TWIST				0x41
#define USB_HID_TIP_SWITCH			0x42
#define USB_HID_SECONDARY_TIP_SWITCH		0x43
#define USB_HID_BARREL_SWITCH			0x44
#define USB_HID_ERASER				0x45
#define USB_HID_TABLET_PICK			0x46

/* Unicode Page */
/*
 * The Unicode Page directly maps to the two-octet form defined
 * in the Unicode Standard.
 */

/* Alphanumeric Display Page */
#define USB_HID_ALPHANUMERIC_DISPLAY		0x01
#define USB_HID_BITMAPPED_DISPLAY		0x02
#define USB_HID_DISPLAY_ATTRIBUTES_REPORT	0x20
#define USB_HID_ASCII_CHARACTER_SET		0x21
#define USB_HID_DATA_READ_BACK			0x22
#define USB_HID_FONT_READ_BACK			0x23
#define USB_HID_DISPLAY_CONTROL_REPORT		0x24
#define USB_HID_CLEAR_DISPLAY			0x25
#define USB_HID_DISPLAY_ENABLE			0x26
#define USB_HID_SCREEN_SAVER_DELAY		0x27
#define USB_HID_SCREEN_SAVER_ENABLE		0x28
#define USB_HID_VERTICAL_SCROLL			0x29
#define USB_HID_HORIZONTAL_SCROLL		0x2a
#define USB_HID_CHARACTER_REPORT		0x2b
#define USB_HID_DISPLAY_DATA			0x2c
#define USB_HID_DISPLAY_STATUS			0x2d
#define USB_HID_STAT_NOT_READY			0x2e
#define USB_HID_STAT_READY			0x2f
#define USB_HID_ERR_NOT_A_LOADABLE_CHARACTER	0x30
#define USB_HID_ERR_FONT_DATA_CANNOT_BE_READ	0x31
#define USB_HID_CURSOR_POSITION_REPORT		0x32
#define USB_HID_ROW				0x33
#define USB_HID_COLUMN				0x34
#define USB_HID_ROWS				0x35
#define USB_HID_COLUMNS				0x36
#define USB_HID_CURSOR_PIXEL_POSITIONING	0x37
#define USB_HID_CURSOR_MODE			0x38
#define USB_HID_CURSOR_ENABLE			0x39
#define USB_HID_CURSOR_BLINK			0x3a
#define USB_HID_FONT_REPORT			0x3b
#define USB_HID_FONT_DATA			0x3c
#define USB_HID_CHARACTER_WIDTH			0x3d
#define USB_HID_CHARACTER_HEIGHT		0x3e
#define USB_HID_CHARACTER_SPACING_HORIZONTAL	0x3f
#define USB_HID_CHARACTER_SPACING_VERTICAL	0x40
#define USB_HID_UNICODE_CHARACTER_SET		0x41
#define USB_HID_FONT_7_SEGMENT			0x42
#define USB_HID_7_SEGMENT_DIRECT_MAP		0x43
#define USB_HID_FONT_14_SEGMENT			0x44
#define USB_HID_14_SEGMENT_DIRECT_MAP		0x45
#define USB_HID_DISPLAY_BRIGHTNESS		0x46
#define USB_HID_DISPLAY_CONTRAST		0x47
#define USB_HID_CHARACTER_ATTRIBUTE		0x48
#define USB_HID_ATTRIBUTE_READBACK		0x49
#define USB_HID_ATTRIBUTE_DATA			0x4a
#define USB_HID_CHAR_ATTR_ENHANCE		0x4b
#define USB_HID_CHAR_ATTR_UNDERLINE		0x4c
#define USB_HID_CHAR_ATTR_BLINK			0x4d
#define USB_HID_BITMAP_SIZE_X			0x80
#define USB_HID_BITMAP_SIZE_Y			0x81
#define USB_HID_BIT_DEPTH_FORMAT		0x83
#define USB_HID_DISPLAY_ORIENTATION		0x84
#define USB_HID_PALETTE_REPORT			0x85
#define USB_HID_PALETTE_DATA_SIZE		0x86
#define USB_HID_PALETTE_DATA_OFFSET		0x87
#define USB_HID_PALETTE_DATA			0x88
#define USB_HID_BLIT_REPORT			0x8a
#define USB_HID_BLIT_RECTANGLE_X1		0x8b
#define USB_HID_BLIT_RECTANGLE_Y1		0x8c
#define USB_HID_BLIT_RECTANGLE_X2		0x8d
#define USB_HID_BLIT_RECTANGLE_Y2		0x8e
#define USB_HID_BLIT_DATA			0x8f
#define USB_HID_SOFT_BUTTON			0x90
#define USB_HID_SOFT_BUTTON_ID			0x91
#define USB_HID_SOFT_BUTTON_SIDE		0x92
#define USB_HID_SOFT_BUTTON_OFFSET_1		0x93
#define USB_HID_SOFT_BUTTON_OFFSET_2		0x94
#define USB_HID_SOFT_BUTTON_REPORT		0x95

/* Medical Instrument Page */
#define USB_HID_MEDICAL_ULTRASOUND		0x01
#define USB_HID_VCR_ACQUISITION			0x20
#define USB_HID_FREEZE_THAW			0x21
#define USB_HID_CLIP_STORE			0x22
#define USB_HID_UPDATE				0x23
#define USB_HID_NEXT				0x24
#define USB_HID_SAVE				0x25
#define USB_HID_PRINT				0x26
#define USB_HID_MICROPHONE_ENABLE		0x27
#define USB_HID_CINE				0x40
#define USB_HID_TRANSMIT_POWER			0x41
#define USB_HID_MONITOR_VOLUME			0x42
#define USB_HID_BEAM_FOCUS			0x43
#define USB_HID_DEPTH				0x44
#define USB_HID_SOFT_STEP_PRIMARY		0x60
#define USB_HID_SOFT_STEP_SECONDARY		0x61
#define USB_HID_DEPTH_GAIN_COMPENSATION		0x70
#define USB_HID_ZOOM_SELECT			0x80
#define USB_HID_ZOOM_ADJUST			0x81
#define USB_HID_SPECTRAL_DOPPLER_MODE_SELECT	0x82
#define USB_HID_SPECTRAL_DOPPLER_ADJUST		0x83
#define USB_HID_COLOR_DOPPLER_MODE_SELECT	0x84
#define USB_HID_COLOR_DOPPLER_ADJUST		0x85
#define USB_HID_MOTION_MODE_SELECT		0x86
#define USB_HID_MOTION_MODE_ADJUST		0x87
#define USB_HID_2D_MODE_SELECT			0x88
#define USB_HID_2D_MODE_ADJUST			0x89
#define USB_HID_SOFT_CONTROL_SELECT		0xa0
#define USB_HID_SOFT_CONTROL_ADJUST		0xa1
